Endpoints for management of files
Hypatos REST API (2.51.0)
The Hypatos API is organized around REST. The majority of the endpoints provide CRUD functionality for resources. The API is also exposing Intent Resources which mimic user intents or actions.
The Hypatos API uses OAuth 2.0 Client Credential Grant to authenticate requests. Before making any requests to any endpoint a client must authenticate with the authorization server and requests an access token from the token endpoint.
POST /auth/token HTTP/1.1
Host: api.cloud.hypatos.ai
Content-Type: application/x-www-form-urlencoded
Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=
grant_type=client_credentialsAuthorization header contains client_id:client_secret encoded as explained in RFC Client Password section.
If the authorization server authenticated the client successfully, an access token is issued. Here is an example successful response:
HTTP/1.1 200 OK
Content-Type: application/json;charset=UTF-8
Cache-Control: no-store
Pragma: no-cache
{
"access_token": "mF_9.B5f-4.1JqM",
"expires_in": 86400,
"scope": "enrichment.write files.read",
"token_type": "Bearer",
}This token can be used to authenticate the requests to API endpoints by sending a Bearer token in the Authorization HTTP header. The following example demonstrates how to use the access token to retrieve a list of documents.
GET /v2/documents HTTP/1.1
Host: api.cloud.hypatos.ai
Authorization: Bearer mF_9.B5f-4.1JqMChanges to this API are released regularly. We use Semantic Versioning 2.0.0 scheme for versioning so that the clients can identify any backward-incompatible changes easily. Briefly summarized one can say, if the MAJOR version of the new API version didn't change you can expect the new version to be backward-compatible.
In order to maximise the stability of our API, we institue rate limits for all of API endpoints. Clients who send too many requests over a given period of time will see error responses that show up as status code 429 Too Many Requests.
When you see error responses with status code 429, it means you exhausted your current quota and need to withhold from sending further requests until the quota is reset. We encourage you not to wait until you get a 429 error but to monitor your quota in each request. In each response you receive from the API, you will find HTTP headers providing the details about your current quota. Here is the list of the HTTP headers:
x-ratelimit-limit: Indicates the quota associated to the client in the current time-window followed by the description of the quota policy.x-ratelimit-remaining: Indicates the number of remaining requests in the current time-windowx-ratelimit-reset: Indicates the number of seconds until quota reset of the current time-window
Please note that IETF is currently in the process of publishing a standard for these headers. Please explore the draft for more details.
A basic technique to gracefully handle rate limits is watch for your quota permanently and increase the time between your request as the quota is decreasing. To recover from a 429 error you need a retry mechanism following an exponential backoff schedule.
Project ids to to find items by. If ommitted, items from all existing projects are returned.
Limit the amount of items returned in the response. If the value exceeds the maximum, then the maximum value will be used.
The field to sort reponse items by.
Used to retrieve documents that are in specific states only. Multiple states can be used for this filtering. By default, documents in all states are returned.
- API EUhttps://api.cloud.hypatos.ai/v2/documents
- API UShttps://api.cloud.hypatos.com/v2/documents
- Mock serverhttps://hypatos.redocly.app/_mock/openapi/documents
- curl
- Java
- Python
- Node.js
- JavaScript
curl -i -X GET \
'https://api.cloud.hypatos.ai/v2/documents?projectId=string&offset=0&limit=20&sort=createdAt&state=done&fileId=string' \
-H 'Authorization: Bearer <YOUR_TOKEN_HERE>'{ "data": [ { … } ], "limit": 20, "offset": 0, "totalCount": 1000 }
Request
Request a processing of a file that was previously uploaded. The fileId in the request body is representing the identifier of the file that was returned by the upload endpoint. As a result of this request a document will be created and its identifier will be returned in the response. The projectId in the request body is an identifier of the project to create the document in.
Payload for processing the given file
External id of the file. Can be used if you want to link the file with an identifier in your system.
- API EUhttps://api.cloud.hypatos.ai/v2/documents/process-file
- API UShttps://api.cloud.hypatos.com/v2/documents/process-file
- Mock serverhttps://hypatos.redocly.app/_mock/openapi/documents/process-file
- curl
- Java
- Python
- Node.js
- JavaScript
curl -i -X POST \
https://api.cloud.hypatos.ai/v2/documents/process-file \
-H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
-H 'Content-Type: application/json' \
-d '{
"fileId": "5349b4ddd2781d08c09890f4",
"projectId": "00000020f51bb4362eee2a4d",
"externalId": "doc-0001",
"externalData": {
"key1": "value1",
"key2": "value2"
}
}'{ "documentId": "6040dc9680b782b365ea77d5", "fileId": "5349b4ddd2781d08c09890f4", "projectId": "00000020f51bb4362eee2a4d" }
- API EUhttps://api.cloud.hypatos.ai/v2/documents/{id}
- API UShttps://api.cloud.hypatos.com/v2/documents/{id}
- Mock serverhttps://hypatos.redocly.app/_mock/openapi/documents/{id}
- curl
- Java
- Python
- Node.js
- JavaScript
curl -i -X GET \
'https://api.cloud.hypatos.ai/v2/documents/{id}' \
-H 'Authorization: Bearer <YOUR_TOKEN_HERE>'Document retrieved.
Identifier of the primary file associated with this document.
List of files associated with this document, each with their assigned role and main file flag.
{ "id": "6040dc9680b782b365ea77d5", "completedAt": "1990-12-31T15:59:60-08:00", "completedBy": "string", "createdAt": "1990-12-31T15:59:60-08:00", "createdBy": "string", "fileId": "5349b4ddd2781d08c09890f4", "files": [ { … } ], "entities": { "currency": "EUR", "items": [ … ], "number": "2018-DE-0011122351", "qty": 2 }, "externalId": "doc-0001", "externalData": { "internalSystemId": "sap-01" }, "projectId": "6040dc9680b782b365ea77d5", "state": "done", "title": "scan-doc-1.jpg", "updatedAt": "1990-12-31T15:59:60-08:00", "updatedBy": "string", "url": "https://example.com/documents/6040dc9680b782b365ea77d5" }
Payload about the transfer
- API EUhttps://api.cloud.hypatos.ai/v2/documents/{id}/transfer
- API UShttps://api.cloud.hypatos.com/v2/documents/{id}/transfer
- Mock serverhttps://hypatos.redocly.app/_mock/openapi/documents/{id}/transfer
- curl
- Java
- Python
- Node.js
- JavaScript
- success
- failure
curl -i -X POST \
'https://api.cloud.hypatos.ai/v2/documents/{id}/transfer' \
-H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
-H 'Content-Type: application/json' \
-d '{
"successful": true
}'- API EUhttps://api.cloud.hypatos.ai/v2/documents/{id}/reject
- API UShttps://api.cloud.hypatos.com/v2/documents/{id}/reject
- Mock serverhttps://hypatos.redocly.app/_mock/openapi/documents/{id}/reject
- curl
- Java
- Python
- Node.js
- JavaScript
curl -i -X POST \
'https://api.cloud.hypatos.ai/v2/documents/{id}/reject' \
-H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
-H 'Content-Type: application/json' \
-d '{
"message": "Document was rejected!"
}'Request
Update the external data for a document with given identifier. The external data are provided as a flat JSON object. The payload of this requests completley overrides the existing external data of a document. To remove the data, justsend empty JSON object {} in the payload.
Please note that the maximum lenght of an key is 50 characters. Any value with a longer key will be omitted. The maximum amount of key-value pairs is limited to 20.
Payload containing the external data.
- API EUhttps://api.cloud.hypatos.ai/v2/documents/{id}/external-data
- API UShttps://api.cloud.hypatos.com/v2/documents/{id}/external-data
- Mock serverhttps://hypatos.redocly.app/_mock/openapi/documents/{id}/external-data
- curl
- Java
- Python
- Node.js
- JavaScript
curl -i -X POST \
'https://api.cloud.hypatos.ai/v2/documents/{id}/external-data' \
-H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
-H 'Content-Type: application/json' \
-d '{
"key1": "value1",
"key2": "value2"
}'Update external id for a given document.
External ID
- API EUhttps://api.cloud.hypatos.ai/v2/documents/{id}/external-id
- API UShttps://api.cloud.hypatos.com/v2/documents/{id}/external-id
- Mock serverhttps://hypatos.redocly.app/_mock/openapi/documents/{id}/external-id
- curl
- Java
- Python
- Node.js
- JavaScript
curl -i -X POST \
'https://api.cloud.hypatos.ai/v2/documents/{id}/external-id' \
-H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
-H 'Content-Type: text/plain' \
-d 15b884b0-d551-4865-bda9-4168800c9d87Title for a given document.
New Title
- API EUhttps://api.cloud.hypatos.ai/v2/documents/{id}/title
- API UShttps://api.cloud.hypatos.com/v2/documents/{id}/title
- Mock serverhttps://hypatos.redocly.app/_mock/openapi/documents/{id}/title
- curl
- Java
- Python
- Node.js
- JavaScript
curl -i -X POST \
'https://api.cloud.hypatos.ai/v2/documents/{id}/title' \
-H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
-H 'Content-Type: text/plain' \
-d 'New Title of Document'Request
Provides a list of states that the specified document has passed through. If the document is still being processed, the number of returned states should not be considered final. Subsequent calls to this endpoint may return additional states as the document continues to progress through the processing pipeline.
- API EUhttps://api.cloud.hypatos.ai/v2/documents/{id}/states
- API UShttps://api.cloud.hypatos.com/v2/documents/{id}/states
- Mock serverhttps://hypatos.redocly.app/_mock/openapi/documents/{id}/states
- curl
- Java
- Python
- Node.js
- JavaScript
curl -i -X GET \
'https://api.cloud.hypatos.ai/v2/documents/{id}/states' \
-H 'Authorization: Bearer <YOUR_TOKEN_HERE>'[ { "state": "done", "updatedAt": "1990-12-31T15:59:60-08:00" } ]